package application;

import java.util.ArrayList;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.paint.Color;

// to store items and create some changes in it
public class Inventory {
	
	private ArrayList<Item> inventory = new ArrayList<>();//The ArrayList to add Items without a limited number
	private String category;
	public Label Errorlabel = new Label();
	
	public Inventory(String category) {//constructor to take names of category
		super();
		this.category = category;
	}
	//methods to add item
	public void newItem(String type,int quantity,double prise ) {//to add Item have just type
		if(findItem(type,true)==-1) {
			inventory.add(new Item(type).setQuantity(quantity).setPrice(prise));		
	}}
	public void newItem(String brand,String type,int quantity,double prise ) {//to add Item have type and brand
		if(findItem(type,true,brand)==-1) {
			inventory.add(new Brand(brand,type).setQuantity(quantity).setPrice(prise));
		}}
	// The setter and getter for Quantity ,Price
	public void setQuantity(String type,int quantity ) {
		if(findItem(type, false)!=-1) { 
			int x=findItem(type, false);
			inventory.get(x).setQuantity(quantity);
		}}
	public void setQuantity(String brand,String type,int quantity ) {
		if(findItem(type, false,brand)!=-1) {
			int x=findItem(type, false,brand);
			inventory.get(x).setQuantity(quantity);
			}}
	public void setPrice(String type,double price ) {
		if(findItem(type, false)!=-1) { 
			int x=findItem(type, false);
			inventory.get(x).setPrice(price);
		  }}
	public void setPrice(String brand,String type,double price ) {
		if(findItem(type, false,brand)!=-1) {
			int x=findItem(type, false,brand);
			inventory.get(x).setPrice(price);
			}}
	public int getQuantity(String type ) {
		if(findItem(type, false)!=-1) {
			int x=findItem(type, false);
			return inventory.get(x).getQuantity();
			}
		return -1;
	}
	public int getQuantity(String brand,String type)  {
		if(findItem(type, false,brand)!=-1) {
			int x=findItem(type, false,brand);
			return inventory.get(x).getQuantity();
			}
		return 0;
		}
	public double getPrice(String type)  {
		if(findItem(type, false)!=-1) {
			int x=findItem(type, false);
			return inventory.get(x).getPrice();
			}
		return Double.NaN;
		}
	public double getPrice(String brand,String type)  {
		if(findItem(type,false,brand)!=-1) {
			int x=findItem(type,false,brand);
			return inventory.get(x).getPrice();
			}
		return Double.NaN;
		}
	// the Update methods for any change in Item and Brand
	public void update(String type,int qtyIncrease)  {
		if(findItem(type, false)!=-1) {
			int x=findItem(type, false);
			 inventory.get(x).update(qtyIncrease);	
		}
	}
	public void update(String brand,String type,int qtyIncrease)  {
		if(findItem(type, false,brand)!=-1) {
			int x=findItem(type, false,brand);
			 inventory.get(x).update(qtyIncrease);	
		}
	}
	public void update(String type,double adjustmentFactor)  {
		if(findItem(type, false)!=-1) {
			int x=findItem(type, false);
			 inventory.get(x).update(adjustmentFactor);	
		}
	}
	public void update(String brand,String type,double adjustmentFactor)  {
		if(findItem(type,false,brand)!=-1) {
			int x=findItem(type, false,brand);
			 inventory.get(x).update(adjustmentFactor);	
		}
	}	
	
		
	// the delete methods for delete any  Item 
	public void Delete(String brand,String type)  {
			if(findItem(type,false,brand)!=-1) {
				int x=findItem(type, false,brand);
				 inventory.remove(x);
			}	
	}
	public void Delete(String type)  {
		if(findItem(type, false)!=-1) {
			int x=findItem(type, false);
			 inventory.remove(x);
		}
	}
	
	
	// Methods to find if Item existed or get index of Item
	private int findItem(String type,boolean warningIfFound)  {//to Know if Item of Type existed
		Errorlabel.setText("");
		int index=-1;int itemsFound=0;
		for (int i = 0; i < inventory.size(); i++) {
			if((inventory.get(i).getType()).equals(type) ) {
				index =inventory.indexOf(inventory.get(i));
				itemsFound++;}
			}
		if (itemsFound == 0 && !warningIfFound) 
			Errorlabel.setText( "Cannot find "+ " " + type);	 
		else if (itemsFound > 0 && warningIfFound) 
			Errorlabel.setText(type + " already exists");
		else if(itemsFound > 1) {
			Errorlabel.setText("Found more than one brand of "+type);
			return-1;}
		return index;
	}
	private int findItem(String type,boolean warningIfFound,String brand)  {//to Know if Item of Type and brand existed
		Errorlabel.setText("");
		int index=-1;int itemsFound=0;
		for (int i = 0; i < inventory.size(); i++) {
			if((inventory.get(i).getType()).equals(type)&&inventory.get(i) instanceof Brand&&brand.equals(((Brand)inventory.get(i)).getBrand())) {
				index=i;
				itemsFound++;}
				}
		if (itemsFound == 0 && !warningIfFound) 
			Errorlabel.setText("Cannot find " + brand + " " + type);
		if (itemsFound > 0 && warningIfFound) 
			Errorlabel.setText(type + " already exists");
		if(itemsFound > 1) { 
			Errorlabel.setText("Found more than one brand of "+brand+" "+type);
			return-1;}
			return index;
	} 
	//to Print items in inventory and total price
	public StringBuilder stockReport() {
		StringBuilder t = new StringBuilder();
		double sum = 0;
		for (int i = 0; i < inventory.size(); i++){
			if (inventory.get(i) instanceof Brand) {
				t.append(((Brand)inventory.get(i)).getBrand()+" "+inventory.get(i).getType()+" - in stock: "
						+inventory.get(i).getQuantity()+", price: $"+String.format("%.2f", inventory.get(i).getPrice())+"\n");	
				sum+=inventory.get(i).getPrice()*(inventory.get(i).getQuantity());
			}else {
				t.append(inventory.get(i).getType()+" - in stock: "
						+inventory.get(i).getQuantity()+", price: $"+String.format("%.2f", inventory.get(i).getPrice())+"\n");
				sum+=inventory.get(i).getPrice()*(inventory.get(i).getQuantity());
			}}
		t.append("Total value: $"+String.format("%.2f", sum)+"\n");
		t.append("\n");
	return t;
	}
}