package application;

import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.stage.Stage;

//to create window to display items when clicked stock report button in main screen

public class Stockpane extends GridPane {

	private Stage StockButtonStage;
	private CheckBox fileBox,areaTextBox ;
	private Text text,finaltext ;
	private Button Exportbttn;
	private TextField ExportField;
	private TextArea textarea;
	
	public Stockpane() {
		
		super.setStyle("-fx-background-color:gray;");
		super.setAlignment(Pos.TOP_LEFT);
		super.setHgap(30);
		super.setVgap(15);
		super.setPadding(new Insets(10, 0, 0, 10));
		
		text = new Text("The following option can"
				+ " be used to print a report");
		finaltext = new Text();
		finaltext.setVisible(false);
		
		Font font = Font.font(null,FontWeight.BOLD,20);
		text.setFont(font);
		finaltext.setFont(font);
		
		fileBox = new CheckBox("Export a copy to a file");
		areaTextBox = new CheckBox("TextArea");
	
		HBox h = new HBox(10);
		h.getChildren().addAll(fileBox,areaTextBox);
		
		ExportField = new TextField();
		ExportField.setVisible(false);
		ExportField.setMaxWidth(300);
		ExportField.setStyle("-fx-text-fill: green;");
		
		Exportbttn = new Button("Export");
		Exportbttn.setVisible(false);
	
		textarea = new TextArea(); 
		textarea.setVisible(false);
		textarea.setEditable(false);
		
		HBox h2 = new HBox(ExportField,textarea);
		h2.setSpacing(50);
		super.add(h, 0, 1);
		super.add(text, 0, 0);
		super.add(h2, 0, 2);
		super.add(Exportbttn, 0, 3);
		super.add(finaltext, 0, 4);
		
		Scene scene = new Scene(this,900,400);
		StockButtonStage = new Stage();
		StockButtonStage.setScene(scene);
		StockButtonStage.setTitle("Stock Report");
		StockButtonStage.show();
	}
	
	/* The setter and getter*/
	public Stage getStockButtonStage() {
		return StockButtonStage;
	}
	public CheckBox getFileBox() {
		return fileBox;
	}
	public CheckBox getAreaTextBox() {
		return areaTextBox;
	}
	public Button getExportbttn() {
		return Exportbttn;
	}
	public TextField getExportField() {
		return ExportField;
	}
	public TextArea getTextarea() {
		return textarea;
	}
	public Text getFinaltext() {
		return finaltext;
	}
	
}